#include "kmodaldemodialog.moc"
#include <qlayout.h>
#include <qradiobutton.h>
#include <qvbox.h>
#include <qlabel.h>
#include <kmessagebox.h>

KModalDemoDialog :: KModalDemoDialog (QWidget* parent) :
KDialogBase(// Typ: Plain, Tabbed, TreeList, IconList
	KDialogBase::Tabbed, 
	// Titel:
	"Modaler Demodialog",
	// Knpfe:
	// Help, Default, OK, Apply, Try, Cancel, Close, User1, User2, User3, No, Yes
	KDialogBase::User1 | KDialogBase::Ok | KDialogBase::Cancel,
	// Default-Knopf
	KDialogBase::Cancel,
	// bergeordnetes Fenster
	parent,
	// interner Name
	"Modaler Demodialog",
	// modal? (= Rest der Anwendung blockieren)
	true,
	// Trennlinie ber Buttons?
	true,
	// Beschriftung fr die drei User-Buttons; nicht benutzte weglassen
	"Test")
{
	// den Knopf "Test" verdrahten:
	connect(this, SIGNAL(user1Clicked()), this, SLOT(showSelection()));

	// erster Karteireiter ************************************************

	// Im Modus "Plain" (Dialog ohne mehrere Seiten) erhlt man die eine Seite mit plainPage().
	// Hier dagegen, im Modus "Tabbed", mssen wir jede Seite zu Fu erzeugen:
	QFrame* page1 = addPage(QString("Stil"));
	QHBoxLayout* styleLayout = new QHBoxLayout(page1, 0, spacingHint());

	QVBoxLayout* outlineLayout = new QVBoxLayout(spacingHint());
	styleLayout->addLayout(outlineLayout); // Layouts verschachteln, aber nicht unbedingt Widgets
	checkOutline = new QCheckBox("Umriss", page1); // in Fenster hngen
	outlineLayout->addWidget(checkOutline); // in Layout-Manager hngen

	groupLinewidth = new QVButtonGroup("Dicke", page1); // grafische UND logische Gruppe
	outlineLayout->addWidget(groupLinewidth);	
	new QRadioButton("Dnn", groupLinewidth); // Adresse wegschmeien; groupLinewidth verwaltet dieses Objekt
	new QRadioButton("Mittel", groupLinewidth);
	new QRadioButton("Dick", groupLinewidth);

	QVBoxLayout* fillLayout = new QVBoxLayout(spacingHint());
	styleLayout->addLayout(fillLayout);
	checkFill = new QCheckBox("Fllung", page1);
	fillLayout->addWidget(checkFill);
	fillLayout->addStretch();

	// Wenn Umriss abgeschaltet/angeschaltet, Radioknpfe ausgrauen/aktivieren:
	connect(checkOutline, SIGNAL(stateChanged(int)), this, SLOT(outlineOnOff(int)));	
		
	// zweiter Karteireiter ************************************************

	QFrame* page2 = addHBoxPage(QString("Farbe")); // Seite mit eingebautem Layout-Manager
	QVBox* fillBox = new QVBox(page2); // Widget mit eingebautem Layout-Manager
	QLabel* fillLabel = new QLabel("Fllfarbe", fillBox);
	fillLabel->setAlignment(Qt::AlignHCenter | Qt::AlignBottom);
	fillColorButton = new KColorButton(QColor(255,255,255), fillBox);
	new QWidget(fillBox); // damit Farbauswahl nicht am unteren Rand klebt
	
	QVBox* outlineBox = new QVBox(page2);
	QLabel* outlineLabel = new QLabel("Umrissfarbe", outlineBox);
	outlineLabel->setAlignment(Qt::AlignHCenter | Qt::AlignBottom);
	outlineColorButton = new KColorButton(QColor(0,0,0), outlineBox);
	new QWidget(outlineBox);
	
	// dritter Karteireiter ************************************************

	QFrame* page3 = addPage(QString("Verschiedenes"));
	QGridLayout* miscLayout = new QGridLayout(page3, 4, 3, spacingHint()); // vier Zeilen, drei Spalten
	
	combo = new KComboBox(true, page3); // true = Benutzereingabe mglich
	miscLayout->addWidget(combo, 0, 0);
	combo->insertItem("ein Eintrag");
	combo->insertItem("noch ein Eintrag");
	combo->insertItem("der dritte Eintrag");

	date = new KDatePicker(page3);
	miscLayout->addMultiCellWidget(date, 1, 3, 0, 0);

	lineEdit = new KLineEdit("Hallo!", page3);
	miscLayout->addWidget(lineEdit, 0, 1);

	spin = new KIntSpinBox(-42, 42, 1, -7, 10, page3); 
	miscLayout->addWidget(spin, 1, 1);

	edit = new KEdit(page3);
	edit->setWordWrap(KEdit::WidgetWidth);
	miscLayout->addMultiCellWidget(edit, 2, 3, 1, 1);

	listBox = new KListBox(page3);
	miscLayout->addMultiCellWidget(listBox, 0, 3, 2, 2);
	listBox->setSelectionMode(KListBox::Multi);
	listBox->insertItem("ein Eintrag");
	listBox->insertItem("noch ein Eintrag");
	listBox->insertItem("der dritte Eintrag");
}

KModalDemoDialog :: ~KModalDemoDialog()
{
}

void KModalDemoDialog :: outlineOnOff(int state)
{
	if(state == 2)
	{
		groupLinewidth->setEnabled(true);
	}

	if(state == 0)
	{
		groupLinewidth->setEnabled(false);
	}
}

void KModalDemoDialog :: showSelection()
{
	QString result;
	result += combo->currentText();
	result += "\n" + (date->getDate()).toString();
	result += "\n" + lineEdit->text();
	result += "\n" + QString().setNum(spin->value());
	result += "\n" + edit->text();
	for(unsigned int i=0; i < listBox->count(); ++i)
	{
		if(listBox->isSelected(i))
		{
			result += "\n" + listBox->item(i)->text();
		}
	}

	// Statische Methoden von KMessageBox: information, error, sorry, questionYesNo ...
	KMessageBox::information(0, result, "Extrem wichtige Infos");
}

